;Schulstundencountdown
;AT90S2313 @ 4.194304MHz

; .------------------.
; | H1 mm:ss pp.p% < |
; | WW-DD hh:mm:ss . |
; '------------------'

;PB0-7 = LCD Datenbus
;PD0   = DCF In
;PD1   = Mode-Taster
;PD2   = Up-Taster
;PD3   = Down-Taster
;PD4   = Licht (Taster + Transistor)
;PD5   = LCD RS
;PD6   = LCD E

.include "../../include/2313def.inc"

.def	op1l	= R1
.def	op1h	= R2
.def	op1e	= R3
.def	op2l	= R4
.def	op2h	= R5

.def	temp	= R16
.def	temp2	= R17
.def	light	= R18
.def	contr	= R19
.def	status	= R20
.def	ttstat	= R21

.def	dcfbit	= R22
.def	dcfcnt	= R23
.def	flags	= R24
.def	subsec	= R25
.def	sek	= R26

.def	op3l	= R27
.def	op3h	= R28

.equ	DBase	= 0x60		;RAM Base Adress for DCF Bits (0x60 for SRAM, 0x00 for R0-R13)
.equ	Base	= DBase+8	;RAM Base Adress for verified Time/Date information
.equ	nBase	= Base+8	;RAM Base Adress for temporary Time/Date information

.equ	RS	= 5
.equ	E	= 6

.equ	MaxHour	= 9

;===============================================================================

.cseg

.org $0000
	rjmp	start	
.org OVF0ADDR				;timer0 overflow (16Hz)
	rjmp	t0ovf

;===============================================================================

timedata:
.dw  7*3600 + 50*60
.dw  8*3600 + 35*60
.dw  8*3600 + 40*60
.dw  9*3600 + 25*60
.dw  9*3600 + 40*60
.dw 10*3600 + 25*60
.dw 10*3600 + 30*60
.dw 11*3600 + 15*60
.dw 11*3600 + 30*60
.dw 12*3600 + 15*60
.dw 12*3600 + 20*60
.dw 13*3600 + 05*60
.dw 13*3600 + 20*60
.dw 14*3600 + 05*60
.dw 14*3600 + 10*60
.dw 14*3600 + 55*60
.dw 15*3600 + 00*60
.dw 15*3600 + 45*60

timetabledata:
.db "H1", "Ch", "Bi", "Fr", "Ch", "De"
.db "H2", "La", "Ma", "Fr", "Ch", "Fr"
.db "H3", "Ma", "Ma", "De", "Mu", "Ph"
.db "H4", "Ek", "Ph", "De", "Mu", "Ph"
.db "H5", "Ek", "Pi", "La", "Ge", "En"
.db "H6", "Ge", "Pi", "La", "Sp", "En"
.db "H7", "Ge", "En", "In", "Sp", "Me"
.db "H8", "Bi", "Wi", "In", "--", "Me"
.db "H9", "Bi", "Wi", "--", "--", "--"

;===============================================================================

start:
	ldi	temp,	LOW(RAMEND)
	out	SPL,	temp

	ldi	temp,	0b11111111
	out	DDRB,	temp
	ldi	temp,	0b00000000
	out	PORTB,	temp
	ldi	temp,	0b01100000
	out	DDRD,	temp
	ldi	temp,	0b00011111
	out	PORTD,	temp

	ldi	temp,	10
	rcall	wait

	ldi	temp,	1<<TOIE0	;timer0: overflow int, Clk/1024
	out	TIMSK,	temp
	ldi	temp,	0x05
	out	TCCR0,	temp


	sbi	ACSR,	ACD		;turn off analog comperator

	clr	dcfbit			;Init
	clr	dcfcnt
	clr	flags
	ser	subsec
	clr	sek
	clr	status
	clr	ttstat

	ldi	temp,	0
	out	EEAR,	temp
	sbi	EECR,	EERE
	in	contr,	EEDR

	rcall	lcdinit

	sei

;===============================================================================

loop:
	in	temp,	MCUCR
	ori	temp,	1<<SE
	out	MCUCR,	temp
	sleep
	rjmp	loop

;===============================================================================

t0ovf:
	push	temp
	in	temp,	SREG
	push	temp

	tst	light			;light key
	breq	lightkey
	dec	light
	brne	contrast
	cbi	DDRD,	4
	sbi	PORTD,	4
	rjmp	dcf
lightkey:
	sbic	PIND,	4
	rjmp	contrast
	sbi	DDRD,	4
	cbi	PORTD,	4
	ldi	light,	80

contrast:				;contrast keys
	sbrc	status,	5
	rjmp	dcf
	sbic	PIND,	2
	rjmp	contrast2
	mov	temp,	contr
	andi	temp,	0b00111111
	cpi	temp,	63
	breq	contrast2
	inc	contr
	rcall	lcdcontrast
	sbr	contr,	1<<6
contrast2:
	sbic	PIND,	3
	rjmp	contrast3
	mov	temp,	contr
	andi	temp,	0b00111111
	cpi	temp,	0
	breq	contrast3
	dec	contr
	rcall	lcdcontrast
	sbr	contr,	1<<6
contrast3:
	sbrs	contr,	6
	rjmp	mode
	sbis	PIND,	2
	rjmp	mode
	sbis	PIND,	3
	rjmp	mode
	cbr	contr,	1<<6
	rcall	savecontrast

mode:					;mode key
	sbic	PIND,	1		;key pressed?
	rjmp	notpressed
	mov	temp,	status		;yes: counter=31?
	andi	temp,	0b00011111
	cpi	temp,	31
	breq	tton			;yes: timetable mode on
	inc	status			;no: increment counter
	sbr	status,	1<<6
	rjmp	dcf
notpressed:				;key not pressed
	sbrs	status,	6		;was pressed?
	rjmp	dcf
	cbr	status,	1<<6		;yes: change mode
	ldi	temp,	1<<7
	eor	status,	temp
	rjmp	dcf
tton:
	sbr	status,	1<<5

dcf:
	sbrc	status,	5
	rcall	timetable
	cpi	subsec,	0xFF		;increment time
	breq	inctimeend
	inc	subsec
	cpi	subsec,	0x10
	brlo	inctimeend
	clr	subsec
	inc	sek
	cpi	sek,	60		;minute
	brlo	newsecond
	clr	sek
	ldi	ZL,	Base+0
	ld	temp2,	Z
	inc	temp2
	mov	temp,	temp2
	st	Z,	temp2
	andi	temp2,	0x0F
	cpi	temp2,	0x0A
	brlo	newminute
	andi	temp,	0xF0
	swap	temp
	inc	temp
	swap	temp
	st	Z,	temp
	cpi	temp,	0x60		;hour
	brlo	newminute
	clr	temp
	st	Z,	temp
	ldi	ZL,	Base+1
	ld	temp2,	Z
	inc	temp2
	mov	temp,	temp2
	st	Z,	temp2
	andi	temp2,	0x0F
	cpi	temp2,	0x0A
	brlo	chkhrs24
	andi	temp,	0xF0
	swap	temp
	inc	temp
	swap	temp
	st	Z,	temp
	rjmp	newminute
chkhrs24:
	cpi	temp,	0x24		;weekdays/days
	brlo	newminute
	clr	temp
	st	Z,	temp
	andi	flags,	0xFD
newminute:
;	rcall	displaytime
newsecond:
	rcall	displaytime
inctimeend:
	in	temp,	PIND		;receive DCF signal
	ldi	temp2,	0xFF
	eor	temp,	temp2
	andi	temp,	0x01
	mov	temp2,	flags		;input changed?
	andi	temp2,	0x01
	cp	temp,	temp2
	breq	nochange
	andi	flags,	0xFE
	sbrc	temp,	0
	ori	flags,	0x01
	cpi	temp,	1		;0 -> 1
	brne	negedge
	ldi	temp,	0xCF
	rcall	lcdcmd
	ldi	temp,	1		;Symbol f�r "Eingang=1"
	rcall	lcdchr
	cpi	dcfcnt,	20
	brsh	endofminute
	rjmp	edgeend
negedge:				;1 -> 0
	ldi	temp,	0xCF
	rcall	lcdcmd
	ldi	temp,	0		;Symbol f�r "Eingang=0"
	rcall	lcdchr
	mov	temp,	dcfbit		;save received DCF bit
	andi	temp,	0x07
	ldi	temp2,	0x01
ramdcfbit:
	tst	temp
	breq	ramdcfbitend
	lsl	temp2
	dec	temp
	rjmp	ramdcfbit
ramdcfbitend:
	mov	temp,	dcfbit
	lsr	temp
	lsr	temp
	lsr	temp
	subi	temp,	-DBase
	ldi	ZH,	0
	mov	ZL,	temp
	ld	temp,	Z
	or	temp,	temp2
	cpi	dcfcnt,	2
	brsh	saveend
	com	temp2
	and	temp,	temp2
saveend:
	st	Z,	temp
	inc	dcfbit
	cpi	dcfbit,	60
	brlo	edgeend
	clr	dcfbit
	rjmp	edgeend	
endofminute:				;end of minute, evaluate received DCF data if correct number of bits
	cpi	dcfbit,	59
	brne	error
	rcall	evaluate
	clr	dcfbit
	rjmp	edgeend
error:
	clr	dcfbit
edgeend:
	clr	dcfcnt
	rjmp	dcfend
nochange:
	inc	dcfcnt
	cpi	dcfcnt,	40
	brlo	dcfend
	clr	dcfcnt
	clr	dcfbit
dcfend:
	pop	temp
	out	SREG,	temp
	pop	temp
	reti
	
;===============================================================================

evaluate:				;dcfbit used as third temp register
	ldi	ZH,	0		;Minutes
	ldi	ZL,	DBase+2
	ld	temp2,	Z
	lsr	temp2
	lsr	temp2
	lsr	temp2
	lsr	temp2
	lsr	temp2
	ldi	ZL,	DBase+3
	ld	temp,	Z
	andi	temp,	0x0F
	lsl	temp
	lsl	temp
	lsl	temp
	add	temp2,	temp
	ldi	ZL,	nBase+0
	st	Z,	temp2
	clr	dcfbit
	rcall	checksum
	
	ldi	ZL,	DBase+3		;Minutes Parity
	ld	temp,	Z
	andi	temp,	0x10
	swap	temp
	andi	dcfbit,	0x01
	cpse	temp,	dcfbit
	rjmp	parityerror
	
	ldi	ZL,	DBase+3		;Hours
	ld	temp2,	Z
	lsr	temp2
	lsr	temp2
	lsr	temp2
	lsr	temp2
	lsr	temp2
	ldi	ZL,	DBase+4
	ld	temp,	Z
	andi	temp,	0x07
	lsl	temp
	lsl	temp
	lsl	temp
	add	temp2,	temp
	ldi	ZL,	nBase+1
	st	Z,	temp2
	clr	dcfbit
	rcall	checksum
	
	ldi	ZL,	DBase+4		;Hours Parity
	ld	temp,	Z
	andi	temp,	0x08
	lsr	temp
	lsr	temp
	lsr	temp
	andi	dcfbit,	0x01
	cpse	temp,	dcfbit
	rjmp	parityerror

	ldi	ZL,	DBase+4		;Days
	ld	temp2,	Z
	andi	temp2,	0xF0
	ldi	ZL,	DBase+5
	ld	temp,	Z
	andi	temp,	0x03
	add	temp2,	temp
	swap	temp2
	ldi	ZL,	nBase+2
	st	Z,	temp2
	clr	dcfbit
	rcall	checksum

	ldi	ZL,	DBase+5		;Weekday
	ld	temp2,	Z
	andi	temp2,	0x1C
	lsr	temp2
	lsr	temp2
	ldi	ZL,	nBase+5
	st	Z,	temp2
	rcall	checksum
	
	ldi	ZL,	DBase+5		;Month
	ld	temp2,	Z
	lsr	temp2
	lsr	temp2
	lsr	temp2
	lsr	temp2
	lsr	temp2
	ldi	ZL,	DBase+6
	ld	temp,	Z
	andi	temp,	0x03
	lsl	temp
	lsl	temp
	lsl	temp
	add	temp2,	temp
	ldi	ZL,	nBase+3
	st	Z,	temp2
	rcall	checksum
	
	ldi	ZL,	DBase+6		;Year
	ld	temp2,	Z
	andi	temp2,	0xFC
	lsr	temp2
	lsr	temp2
	ldi	ZL,	DBase+7
	ld	temp,	Z
	andi	temp,	0x03
	swap	temp
	lsl	temp
	lsl	temp
	add	temp2,	temp
	ldi	ZL,	nBase+4
	st	Z,	temp2
	rcall	checksum
	
	ldi	ZL,	DBase+7		;Parity Date
	ld	temp,	Z
	andi	temp,	0x04
	lsr	temp
	lsr	temp
	andi	dcfbit,	0x01
	cpse	temp,	dcfbit
	rjmp	parityerror
	
	clr	subsec			;successfully received a DCF telegram
	clr	sek
	ori	flags,	0x02
	ldi	temp,	8		;copy temporary time to verified time RAM locations
	ldi	ZH,	0
ramcopyloop:
	ldi	ZL,	nBase-1
	add	ZL,	temp
	ld	temp2,	Z
	ldi	ZL,	Base-1
	add	ZL,	temp
	st	Z,	temp2
	dec	temp
	brne	ramcopyloop
	rcall	displaytime
	ret
parityerror:
	ret
	
;===============================================================================

checksum:
	ldi	temp,	8
checksumloop:
	sbrc	temp2,	0
	inc	dcfbit
	lsr	temp2
	dec	temp
	brne	checksumloop
	ret

;===============================================================================

displaytime:				;displays date and time
	ldi	temp,	0xC0
	rcall	lcdcmd
	clr	ZH
	ldi	ZL,	Base+5		;weekday
	ld	temp,	Z
	dec	temp
	rcall	displayweekday

	ldi	temp,	'-'		;day
	rcall	lcdchr
	ldi	ZL,	Base+2
	rcall	displayram

	ldi	temp,	' '		;hour
	rcall	lcdchr
	ldi	ZL,	Base+1
	rcall	displayram
	ldi	temp,	':'		;minute
	rcall	lcdchr
	ldi	ZL,	Base+0
	rcall	displayram
	ldi	temp,	':'		;second
	rcall	lcdchr
	clr	op1e
	clr	op1h
	mov	op1l,	sek
	clr	op3h
	ldi	op3l,	10
	rcall	bin2bcd
	subi	temp,	-48
	rcall	lcdchr
	mov	temp,	op1l
	subi	temp,	-48
	rcall	lcdchr

	sbrc	status,	5		;timetable mode
	rjmp	disptimeend

;===============================================================================

	clr	ZH			;Sa + So keine Schule
	ldi	ZL,	Base+5
	ld	temp,	Z
	cpi	temp,	6
	brlo	PC+2
	rjmp	schoolsout

	clr	ZH			;Bei 18:12:16 w�re �berlauf
	ldi	ZL,	Base+1
	ld	temp,	Z
	cpi	temp,	0x18
	brlo	PC+2
	rjmp	schoolsout

	mov	op1l,	sek		;Zeit in Sekunden nach op1
	clr	op1h

	clr	ZH	
	ldi	ZL,	Base+0
	ld	temp,	Z+
	rcall	bcd2bin
	mov	op2l,	temp2
	clr	op2h
	ldi	op3l,	60
	clr	op3h
	rcall	multiply

	ld	temp,	Z
	rcall	bcd2bin
	mov	op2l,	temp2
	clr	op2h
	ldi	op3l,	LOW(3600)
	ldi	op3h,	HIGH(3600)
	rcall	multiply

	ldi	ZH,	HIGH(timedata*2+26) ;Schulende nach op2
	ldi	ZL,	LOW(timedata*2+26)
	lpm
	mov	op2l,	r0
	adiw	ZL,	1
	lpm
	mov	op2h,	r0
	cp	op1l,	op2l		;Vergleichen
	cpc	op1h,	op2h
	brlo	PC+2
	rjmp	schoolsout

	ldi	ZH,	HIGH(timedata*2) ;Schulbeginn nach op2
	ldi	ZL,	LOW(timedata*2)
	lpm
	mov	op2l,	r0
	adiw	ZL,	1
	lpm
	mov	op2h,	r0
	cp	op1l,	op2l		;Vergleichen
	cpc	op1h,	op2h
	brsh	PC+2
	rjmp	schoolsout

	ldi	temp,	MaxHour*2-1
checkloop:
	ldi	ZH,	HIGH(timedata*2);Stundenbeginn nach op2
	ldi	ZL,	LOW(timedata*2)
	mov	temp2,	temp
	lsl	temp2			;temp2 = temp2 * 2
	add	ZL,	temp2
	brcc	PC+2
	inc	ZH
	lpm
	mov	op2l,	r0
	adiw	ZL,	1
	lpm
	mov	op2h,	r0
	cp	op1l,	op2l		;Vergleichen
	cpc	op1h,	op2h
	brsh	checkloopend		;Nach Stundenbeginn: aktuelle Stunde gefunden

	dec	temp
	cpi	temp,	255
	brne	checkloop
checkloopend:
	adiw	ZL,	1		;Stundenende nach op3
	lpm
	mov	op3l,	r0
	adiw	ZL,	1
	lpm
	mov	op3h,	r0

	sub	op3l,	op2l		;Stundenl�nge (Stundenende - Stundenbeginn) nach op3
	sbc	op3h,	op2h
	sub	op1l,	op2l		;Verstrichene Zeit (Zeit - Stundenbeginn) nach op1
	sbc	op1h,	op2h
	mov	op2l,	op3l		;Stundenl�nge nach op2
	mov	op2h,	op3h

	push	op2l
	mov	op2l,	temp
	ldi	temp,	0x8F
	rcall	lcdcmd
	ldi	temp,	2		;Verstrichen: Zeichen 2
	sbrs	status,	7
	rjmp	disphour
	sub	op3l,	op1l		;Restzeit = Stundenl�nge - Verstrichene Zeit nach op1
	sbc	op3h,	op1h
	mov	op1l,	op3l
	mov	op1h,	op3h
	ldi	temp,	3		;Rest: Zeichen 3

;===============================================================================

disphour:
	rcall	lcdchr			;Modus anzeigen
	ldi	temp,	0x80		;Aktuelle Stunde anzeigen
	rcall	lcdcmd
	ldi	ZH,	HIGH(hourdata*2)
	ldi	ZL,	LOW(hourdata*2)
	lsl	op2l			;op3h = op3h * 2
	add	ZL,	op2l
	brcc	PC+2
	inc	ZH
	lpm
	mov	temp,	r0
	rcall	lcdchr
	adiw	ZL,	1
	lpm
	mov	temp,	r0
	rcall	lcdchr
	pop	op2l

	push	op1h			;Verstrichene/Restzeit sichern und anzeigen
	push	op1l
	ldi	temp,	' '
	rcall	lcdchr
	ldi	op3h,	HIGH(600)
	ldi	op3l,	LOW(600)
	rcall	bin2bcd
	subi	temp,	-48
	cpi	temp,	48
	brne	PC+2
	ldi	temp,	' '
	rcall	lcdchr
	clr	op3h
	ldi	op3l,	60
	rcall	bin2bcd
	subi	temp,	-48
	rcall	lcdchr
	ldi	temp,	':'
	rcall	lcdchr
	ldi	op3l,	10
	rcall	bin2bcd
	subi	temp,	-48
	rcall	lcdchr
	mov	temp,	op1l
	subi	temp,	-48
	rcall	lcdchr
	pop	op1l
	pop	op1h

	push	op2h			;op1 = op1 * 1000
	push	op2l
	ldi	op3h,	HIGH(1000)
	ldi	op3l,	LOW(1000)
	mov	op2h,	op1h
	mov	op2l,	op1l
	clr	op1l
	clr	op1h
	clr	op1e
	rcall	multiply
	pop	op2l
	pop	op2h

	clr	op3l			;op1 = op1 / op2 (rounded)
	clr	op3h
	clr	temp
	ldi	temp2,	1
divideloop:
	cp	op1l,	op2l
	cpc	op1h,	op2h
	cpc	op1e,	temp
	brlo	divideround
	sub	op1l,	op2l
	sbc	op1h,	op2h
	sbc	op1e,	temp
	add	op3l,	temp2
	adc	op3h,	temp
	rjmp	divideloop
divideround:
	lsr	op2h
	ror	op2l
	cp	op1l,	op2l
	cpc	op1h,	op2h
	brlo	divideend
	add	op3l,	temp2
	adc	op3h,	temp
divideend:
	mov	op1l,	op3l
	mov	op1h,	op3h

	ldi	op3h,	HIGH(1000)	;Prozente anzeigen
	ldi	op3l,	LOW(1000)
	rcall	bin2bcd
	subi	temp,	-48
	mov	op2l,	temp
	cpi	temp,	48
	brne	PC+2
	ldi	temp,	' '
	rcall	lcdchr

	clr	op3h
	ldi	op3l,	100
	rcall	bin2bcd
	subi	temp,	-48
	ldi	temp2,	48
	cp	op2l,	temp2
	brne	PC+4
	cpi	temp,	48
	brne	PC+2
	ldi	temp,	' '
	rcall	lcdchr

	clr	op3h
	ldi	op3l,	10
	rcall	bin2bcd
	subi	temp,	-48
	rcall	lcdchr
	ldi	temp,	'.'
	rcall	lcdchr
	mov	temp,	op1l
	subi	temp,	-48
	rcall	lcdchr
	ldi	temp,	'%'
	rcall	lcdchr

	rjmp	disptimeend

;===============================================================================

schoolsout:
	ldi	temp,	0x80
	rcall	lcdcmd
	ldi	ZH,	HIGH(schoolsoutdata*2)
	ldi	ZL,	LOW(schoolsoutdata*2)
	ldi	temp,	16
	mov	op1l,	temp
	rcall	lcdtext

disptimeend:
	ret

;===============================================================================

timetable:
	mov	temp,	ttstat
	andi	temp,	0b00011111
	cpi	temp,	1
	brsh	tt1

	ldi	temp,	0x80		;clear first line
	rcall	lcdcmd
	ldi	temp,	16
	mov	op1l,	temp
	ldi	ZH,	HIGH(nixdata*2)
	ldi	ZL,	LOW(nixdata*2)
	rcall	lcdtext
	ldi	temp,	0x80		;load weekday
	rcall	lcdcmd
	clr	op2l
	mov	temp,	op2l
	rcall	displayweekday
	inc	ttstat

tt1:
	mov	temp,	ttstat
	andi	temp,	0b00011111
	cpi	temp,	2
	brsh	tt2
	sbis	PIND,	1
	rjmp	ttend
	inc	ttstat
	rjmp	ttend

tt2:
	mov	temp,	ttstat
	andi	temp,	0b00011111
	cpi	temp,	3
	brsh	tt5

	sbrs	ttstat,	6
	rjmp	tt3
	sbic	PIND,	2
	rjmp	ttincday

tt3:
	sbrs	ttstat,	5
	rjmp	tt4
	sbic	PIND,	3
	rjmp	ttdecday

tt4:
	sbrs	ttstat,	7
	rjmp	ttend
	sbis	PIND,	1
	rjmp	ttend
	inc	ttstat
	clr	op2h
	rcall	ttdisphour
	rjmp	ttend

tt5:
	mov	temp,	ttstat
	andi	temp,	0b00011111
	cpi	temp,	4
	brsh	ttend

	sbrs	ttstat,	6
	rjmp	tt6
	sbic	PIND,	2
	rjmp	ttinchour

tt6:
	sbrs	ttstat,	5
	rjmp	tt7
	sbic	PIND,	3
	rjmp	ttdechour

tt7:
	sbrs	ttstat,	7
	rjmp	ttend
	sbis	PIND,	1
	rjmp	ttend

	ldi	temp,	0x80
	rcall	lcdcmd
	ldi	temp,	16
	mov	op1l,	temp
	ldi	ZH,	HIGH(nixdata*2)
	ldi	ZL,	LOW(nixdata*2)
	rcall	lcdtext

	cbr	status,	1<<7
	clr	ttstat
	ret

ttincday:	
	ldi	temp,	4
	cp	op2l,	temp
	breq	ttend
	inc	op2l
	ldi	temp,	0x80
	rcall	lcdcmd
	mov	temp,	op2l
	rcall	displayweekday
	rjmp	ttend

ttdecday:
	ldi	temp,	0
	cp	op2l,	temp
	breq	ttend
	dec	op2l
	ldi	temp,	0x80
	rcall	lcdcmd
	mov	temp,	op2l
	rcall	displayweekday
	rjmp	ttend

ttinchour:
	ldi	temp,	MaxHour-1
	cp	op2h,	temp
	breq	ttend
	inc	op2h
	rcall	ttdisphour
	rjmp	ttend

ttdechour:
	ldi	temp,	0
	cp	op2h,	temp
	breq	ttend
	dec	op2h
	rcall	ttdisphour
	rjmp	ttend

ttend:
	andi	ttstat,	0b00011111
	sbis	PIND,	1
	sbr	ttstat,	1<<7
	sbis	PIND,	2
	sbr	ttstat,	1<<6
	sbis	PIND,	3
	sbr	ttstat,	1<<5
	ret

;===============================================================================

ttdisphour:
	push	op2h
	clr	op1l			;op1l = op2h * 12
	ldi	temp,	16
	ldi	temp2,	12
multi12loop:
	lsr	temp2
	brcc	multi12noadd
	add	op1l,	op2h
multi12noadd:
	lsl	op2h
	dec	temp
	brne	multi12loop
	pop	op2h

	ldi	ZH,	HIGH(timetabledata*2)
	ldi	ZL,	LOW(timetabledata*2)
	add	ZL,	op1l
	brcc	PC+2
	inc	ZH
	ldi	temp,	0x83
	rcall	lcdcmd
	ldi	temp,	2
	mov	op1l,	temp
	rcall	lcdtext
	ldi	temp,	':'
	rcall	lcdchr
	ldi	temp,	' '
	rcall	lcdchr
	mov	temp,	op2l
	lsl	temp
	add	ZL,	temp
	brcc	PC+2
	inc	ZH
	ldi	temp,	2
	mov	op1l,	temp
	rcall	lcdtext
	ret

;===============================================================================

displayram:				;displays packed BCD value from RAM on the LCD
	ld	temp,	Z
	swap	temp
	andi	temp,	0x0F
	subi	temp,	-48
	rcall	lcdchr
	ld	temp,	Z
	andi	temp,	0x0F
	subi	temp,	-48
	rcall	lcdchr
	ret

;===============================================================================

displayweekday:
	lsl	temp
	ldi	ZH,	HIGH(weekdaydata*2)
	ldi	ZL,	LOW(weekdaydata*2)
	add	ZL,	temp
	brcc	PC+2
	inc	ZH
	ldi	temp,	2
	mov	op1l,	temp
	rcall	lcdtext
	ret

;===============================================================================

multiply:				;op1 = op1 + (op2 * op3)
	ldi	temp,	16
	ldi	temp2,	0
multiloop:
	lsr	op3h
	ror	op3l
	brcc	multinoadd
	add	op1l,	op2l
	adc	op1h,	op2h
	adc	op1e,	temp2
multinoadd:
	lsl	op2l
	rol	op2h
	rol	temp2
	dec	temp
	brne	multiloop
	ret

;===============================================================================

bin2bcd:				;Wandelt op1 in eine Stelle um, Ergebnis in temp
	clr	temp			;Z�hler auf Null
	ldi	temp2,	0
bin2bcdloop:
	cp	op1l,	op3l		;Vergleiche
	cpc	op1h,	op3h
	cpc	op1e,	temp2
	brlo	bin2bcdend		;Bin�rzahl kleiner, fertig
	sub	op1l,	op3l		;Subtrahiere Dezimalzahl
	sbc	op1h,	op3h
	sbc	op1e,	temp2
	inc	temp			;Erh�he Z�hler
	rjmp	bin2bcdloop		;Weiter vergleichen/subtrahieren
bin2bcdend:
	ret

;===============================================================================

bcd2bin:				;converts packed BCD (temp) to binary (temp2)
	mov	temp2,	temp
	andi	temp2,	0x0F
bcd2binloop:
	subi	temp,	0x10
	brcs	bcd2binend
	subi	temp2,	-10
	rjmp	bcd2binloop
bcd2binend:
	ret

;===============================================================================

lcdinit:				;Initialisiert und l�scht das LCD f�r 3,3V
	ldi	temp,	0x39		;8-Bit Datenl�nge, 2 Zeilen, Instruction table 1
	rcall	lcdcmd
	ldi	temp,	0x1C		;BS: 1/5, 2 zeiliges LCD
	rcall	lcdcmd
	ldi	temp,	0x55		;Booster ein, Kontrast C5, C4 setzen
	rcall	lcdcmd
	ldi	temp,	0x6D		;Spannungsfolger und Verst�rkung setzen
	rcall	lcdcmd
	ldi	temp,	0x78		;Kontrast C3, C2, C1, C0 setzen
	rcall	lcdcmd
	ldi	temp,	0x0C		;Display ein, Cursor aus
	rcall	lcdcmd
	ldi	temp,	0x06		;Cursor Auto-Increment
	rcall	lcdcmd

	ldi	temp,	0x38		;8-Bit Datenl�nge, 2 Zeilen, Instruction table 0
	rcall	lcdcmd

	ldi	temp,	8
	mov	op1l,	temp
	ldi	ZH,	HIGH(chardata0*2) ;Zeichen 0 = Funkturm
	ldi	ZL,	LOW(chardata0*2)
	ldi	temp,	0x40
	rcall	lcdcmd
	rcall	lcdtext

	ldi	ZH,	HIGH(chardata1*2) ;Zeichen 1 = Funkturm mit Funkwelle
	ldi	ZL,	LOW(chardata1*2)
	ldi	temp,	0x48
	rcall	lcdcmd
	rcall	lcdtext

	ldi	ZH,	HIGH(chardata2*2) ;Zeichen 2 = Pfeil nach unten
	ldi	ZL,	LOW(chardata2*2)
	ldi	temp,	0x50
	rcall	lcdcmd
	rcall	lcdtext

	ldi	ZH,	HIGH(chardata3*2) ;Zeichen 3 = Pfeil nach oben
	ldi	ZL,	LOW(chardata3*2)
	ldi	temp,	0x58
	rcall	lcdcmd
	rcall	lcdtext

	ldi	temp,	0x39		;8-Bit Datenl�nge, 2 Zeilen, Instruction table 1
	rcall	lcdcmd

	ldi	temp,	0x01		;Display l�schen, Cursor Home
	rcall	lcdcmd

	ldi	temp,	100		;1ms warten
	rcall	wait

	rcall	lcdcontrast		;Kontrast wiederherstellen

	ret

;===============================================================================

lcdcontrast:
	mov	temp,	contr		;C4, C5
	swap	temp
	andi	temp,	0b00000011
	ori	temp,	0b01010100
	rcall	lcdcmd
	mov	temp,	contr		;C0, C1, C2, C3
	andi	temp,	0b00001111
	ori	temp,	0b01110000
	rcall	lcdcmd
	ret

savecontrast:
	ldi	temp,	0		;Kontrastwert speichern
	out	EEAR,	temp
	out	EEDR,	contr
	sbi	EECR,	EEMWE
	sbi	EECR,	EEWE
	sbic	EECR,	EEWE
	rjmp	PC-1
	ret

;===============================================================================

lcdcmd:					;Sendet den Befehl in temp ans LCD
	out	PORTB,	temp
	cbi	PORTD,	RS
	sbi	PORTD,	E
	cbi	PORTD,	E
	ldi	temp,	3		;30�s warten
	rcall	wait
	ret

lcdchr:					;Sendet das Zeichen in temp ans LCD
	out	PORTB,	temp
	sbi	PORTD,	RS
	sbi	PORTD,	E
	cbi	PORTD,	E
	ldi	temp,	3		;30�s warten
	rcall	wait
	ret

;===============================================================================

lcdtext:				;displays text from program memory on the LCD
	clr	op1h
lcdtextloop:
	lpm
	mov	temp,	r0
	rcall	lcdchr
	adiw	ZL,	1
	inc	op1h
	cp	op1h,	op1l
	brlo	lcdtextloop
	ret

;===============================================================================

wait:					;Wartet temp * 10�s @ 4.194304MHz
	ldi	temp2,	0x0C
waitloop:
	dec	temp2
	brne	waitloop
	ldi	temp2,	0x0C
	dec	temp
	brne	waitloop
	ret

;===============================================================================

hourdata:
.db "H1", "P1", "H2", "P2", "H3", "P3", "H4", "P4", "H5", "P5", "H6", "P6", "H7", "P7", "H8", "P8", "H9"

;===============================================================================

weekdaydata:
.db "MO", "TU", "WE", "TH", "FR", "SA", "SU"

;===============================================================================

nixdata:
.db "                "

schoolsoutdata:
.db "School's out :-)"

chardata0:
.db 0x00, 0x00, 0x04, 0x0A, 0x04, 0x04, 0x04, 0x00

chardata1:
.db 0x0E, 0x11, 0x04, 0x0A, 0x04, 0x04, 0x04, 0x00

chardata2:
.db 0x04, 0x04, 0x04, 0x04, 0x1F, 0x0E, 0x04, 0x00

chardata3:
.db 0x04, 0x0E, 0x1F, 0x04, 0x04, 0x04, 0x04, 0x00